diff --git a/src/main/java/net/minecraft/core/block/Blocks.java b/src/main/java/net/minecraft/core/block/Blocks.java
index be800a530..92b38f0d2 100644
--- a/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/src/main/java/net/minecraft/core/block/Blocks.java
@@ -43,6 +43,7 @@ public final class Blocks {
     public static Block BASALT_POLISHED;
     public static Block SLATE_POLISHED;
     public static Block PERMAFROST_POLISHED;
+    public static Block NETHERRACK_POLISHED;
 
     public static Block PILLAR_MARBLE;
     public static Block CAPSTONE_MARBLE;
@@ -54,6 +55,7 @@ public final class Blocks {
     public static Block LIMESTONE_CARVED;
     public static Block BASALT_CARVED;
     public static Block PERMAFROST_CARVED;
+    public static Block NETHERRACK_CARVED;
 
     public static Block PLANKS_OAK;
     public static Block PLANKS_OAK_PAINTED;
@@ -150,6 +152,8 @@ public final class Blocks {
 
     public static Block SPONGE_DRY;
     public static Block SPONGE_WET;
+    public static Block PUMICE_DRY;
+    public static Block PUMICE_WET;
 
     public static Block MOSS_STONE;
     public static Block MOSS_BASALT;
@@ -388,8 +392,16 @@ public final class Blocks {
     public static Block PUMPKIN_CARVED_ACTIVE;
     public static Block PUMPKIN_REDSTONE;
 
+    public static Block COBBLE_NETHERRACK;
+    public static Block COBBLE_NETHERRACK_IGNEOUS;
+    public static Block COBBLE_NETHERRACK_MOSSY;
     public static Block NETHERRACK;
-    public static Block NETHERRACK_IGNEOUS;
+    public static Block BRICK_NETHERRACK;
+    public static Block SLAB_NETHERRACK_POLISHED;
+    public static Block SLAB_COBBLE_NETHERRACK;
+    public static Block SLAB_BRICK_NETHERRACK;
+    public static Block STAIRS_COBBLE_NETHERRACK;
+    public static Block STAIRS_BRICK_NETHERRACK;
 
     public static Block SOULSAND;
 
@@ -490,6 +502,8 @@ public final class Blocks {
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
         PERMAFROST_POLISHED = new Block("permafrost.polished", "minecraft:block/permafrost_polished", 865, Material.permafrost).withSound(BlockSounds.PERMAFROST).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+        NETHERRACK_POLISHED = new Block("netherrack.polished", "minecraft:block/netherrack_polished", 866, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.4F).withDisabledNeighborNotifyOnMetadataChange()
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
         PILLAR_MARBLE = new AxisAlignedBlock("pillar.marble", "minecraft:block/pillar_marble", 20, Material.marble).withSound(BlockSounds.STONE).withHardness(1.0F).withBlastResistance(10F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
@@ -509,8 +523,10 @@ public final class Blocks {
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
         PERMAFROST_CARVED = new Block("permafrost.carved", "minecraft:block/permafrost_carved", 44, Material.permafrost).withSound(BlockSounds.PERMAFROST).withHardness(2.0F).withBlastResistance(10F).withDisabledStats()
             .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
+        NETHERRACK_CARVED = new Block("netherrack.carved", "minecraft:block/netherrack_carved", 45, Material.netherrack).withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F).withDisabledStats()
+            .withTags(BlockTags.NOT_IN_CREATIVE_MENU, BlockTags.MINEABLE_BY_PICKAXE);
 
-        PLANKS_OAK = new Block("planks.oak", "minecraft:block/planks_oak", 50, Material.wood).withSound(BlockSounds.WOOD).withHardness(2.0F).withBlastResistance(5F).withDisabledNeighborNotifyOnMetadataChange()
+        PLANKS_OAK = new PlanksBlock("planks.oak", "minecraft:block/planks_oak", 50, Material.wood).withSound(BlockSounds.WOOD).withHardness(2.0F).withBlastResistance(5F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.FENCES_CONNECT, BlockTags.MINEABLE_BY_AXE);
         PLANKS_OAK_PAINTED = new PaintedPlanksBlock("planks.oak.painted", "minecraft:block/planks_oak_painted", 51).withSound(BlockSounds.WOOD).withHardness(2.0F).withBlastResistance(5F).withDisabledNeighborNotifyOnMetadataChange()
             .setBlockItem((b) -> new PaintedBlockItem(b, false))
@@ -573,7 +589,7 @@ public final class Blocks {
         BRICK_IRON = new Block("brick.iron", "minecraft:block/brick_iron", 133, Material.metal).withSound(BlockSounds.METAL).withHardness(5F).withBlastResistance(10F).withOverrideColor(MaterialColor.iron)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
-        SLAB_PLANKS_OAK = new SlabBlock(PLANKS_OAK, "minecraft:block/slab_planks_oak", 140).withSound(BlockSounds.WOOD).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
+        SLAB_PLANKS_OAK = new PaintableSlabBlock(PLANKS_OAK, "minecraft:block/slab_planks_oak", 140).withSound(BlockSounds.WOOD).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
             .withTags(BlockTags.MINEABLE_BY_AXE);
         SLAB_COBBLE_STONE = new SlabBlock(COBBLE_STONE, "minecraft:block/slab_cobble_stone", 141).withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
@@ -615,7 +631,7 @@ public final class Blocks {
         SLAB_BASALT_POLISHED = new SlabBlock(BASALT_CARVED, "minecraft:block/slab_basalt_carved", 159).withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
-        STAIRS_PLANKS_OAK = new StairsBlock(PLANKS_OAK, "minecraft:block/stairs_planks_oak", 160).withSound(BlockSounds.WOOD).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
+        STAIRS_PLANKS_OAK = new PaintableStairsBlock(PLANKS_OAK, "minecraft:block/stairs_planks_oak", 160).withSound(BlockSounds.WOOD).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
             .withTags(BlockTags.MINEABLE_BY_AXE);
         STAIRS_COBBLE_STONE = new StairsBlock(COBBLE_STONE, "minecraft:block/stairs_cobble_stone", 161).withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
@@ -637,7 +653,7 @@ public final class Blocks {
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
         STAIRS_BRICK_CLAY = new StairsBlock(BRICK_CLAY, "minecraft:block/stairs_brick_clay", 170).withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
-        STAIRS_PLANKS_PAINTED = new StairsBlock(PLANKS_OAK_PAINTED, "minecraft:block/stairs_planks_oak_painted", 171).withSound(BlockSounds.WOOD).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
+        STAIRS_PLANKS_PAINTED = new PaintedStairsBlock(PLANKS_OAK_PAINTED, "minecraft:block/stairs_planks_oak_painted", 171).withSound(BlockSounds.WOOD).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
             .setBlockItem(BlockItemStairsPainted::new)
             .withTags(BlockTags.MINEABLE_BY_AXE);
         STAIRS_BRICK_SLATE = new StairsBlock(BRICK_SLATE, "minecraft:block/stairs_brick_slate", 172).withSound(BlockSounds.STONE).withDisabledNeighborNotifyOnMetadataChange().withLitInteriorSurface(true)
@@ -686,6 +702,10 @@ public final class Blocks {
             .withTags(BlockTags.MINEABLE_BY_SHEARS);
         SPONGE_WET = new SpongeBlock("sponge.wet", "minecraft:block/sponge_wet", 231, true).withSound(BlockSounds.GRASS).withHardness(1.0F).withOverrideColor(MaterialColor.paintedYellow)
             .withTags(BlockTags.MINEABLE_BY_SHEARS);
+        PUMICE_DRY = new PumiceBlock("pumice.dry", "minecraft:block/pumice_dry", 232, false).withSound(BlockSounds.STONE).withHardness(0.6F).withOverrideColor(MaterialColor.fire)
+            .withTags(BlockTags.MINEABLE_BY_SHEARS);
+        PUMICE_WET = new PumiceBlock("pumice.wet", "minecraft:block/pumice_wet", 233, true).withSound(BlockSounds.STONE).withHardness(1.0F).withLightEmission(0.625F).withOverrideColor(MaterialColor.fire)
+            .withTags(BlockTags.MINEABLE_BY_SHEARS);
 
         MOSS_STONE = new MossBlock("moss.stone", "minecraft:block/moss_stone", 240, STONE.id).withSound(BlockSounds.STONE).withHardness(1.5F).withBlastResistance(10F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.GROWS_FLOWERS, BlockTags.GROWS_SUGAR_CANE);
@@ -962,7 +982,7 @@ public final class Blocks {
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
         DISPENSER_COBBLE_STONE = new DispenserBlock("dispenser.cobble.stone", "minecraft:block/dispenser_cobble_stone", 560).withSound(BlockSounds.STONE).withHardness(3.5F).withDisabledNeighborNotifyOnMetadataChange().withImmovableFlagSet()
-            .withTags(BlockTags.MINEABLE_BY_PICKAXE);;
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
         TRAPDOOR_PLANKS_OAK = new TrapDoorBlock("trapdoor.planks.oak", "minecraft:block/trapdoor_planks_oak", 570, Material.wood).withSound(BlockSounds.WOOD).withHardness(3F).withDisabledNeighborNotifyOnMetadataChange()
             .withTags(BlockTags.MINEABLE_BY_AXE);
@@ -1108,9 +1128,25 @@ public final class Blocks {
         PUMPKIN_REDSTONE = new RedstonePumpkinBlock("pumpkin.redstone", "minecraft:block/pumpkin_redstone", 793).withSound(BlockSounds.WOOD).withHardness(1.0F).withDisabledNeighborNotifyOnMetadataChange();
 
 
-        NETHERRACK = new Block("netherrack", "minecraft:block/netherrack", 800, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.4F)
+        COBBLE_NETHERRACK = new Block("cobble.netherrack", "minecraft:block/cobble_netherrack", 800, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.4F)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN);
+        COBBLE_NETHERRACK_IGNEOUS = new Block("cobble.netherrack.igneous", "minecraft:block/cobble_netherrack_igneous", 801, Material.netherrack).withSound(BlockSounds.STONE).withHardness(1.25F).withBlastResistance(7F).withLightEmission(10)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+        COBBLE_NETHERRACK_MOSSY = new Block("cobble.netherrack.mossy", "minecraft:block/cobble_netherrack_mossy", 802, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.4F)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN);
-        NETHERRACK_IGNEOUS = new Block("netherrack.igneous", "minecraft:block/netherrack_igneous", 801, Material.netherrack).withSound(BlockSounds.STONE).withHardness(1.25F).withBlastResistance(7F).withLightEmission(10)
+        NETHERRACK = new Block("netherrack", "minecraft:block/netherrack", 803, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.32F)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.INFINITE_BURN);
+        BRICK_NETHERRACK = new Block("brick.netherrack", "minecraft:block/brick_netherrack", 804, Material.netherrack).withSound(BlockSounds.STONE).withHardness(0.4F)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+        SLAB_NETHERRACK_POLISHED = new SlabBlock(NETHERRACK_CARVED, "minecraft:block/slab_netherrack_polished", 805).withSound(BlockSounds.STONE).withHardness(0.4F)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+        SLAB_COBBLE_NETHERRACK = new SlabBlock(COBBLE_NETHERRACK, "minecraft:block/slab_cobble_netherrack", 806).withSound(BlockSounds.STONE).withHardness(0.4F)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+        SLAB_BRICK_NETHERRACK = new SlabBlock(BRICK_NETHERRACK, "minecraft:block/slab_brick_netherrack", 807).withSound(BlockSounds.STONE).withHardness(0.4F)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+        STAIRS_COBBLE_NETHERRACK = new StairsBlock(COBBLE_NETHERRACK, "minecraft:block/stairs_cobble_netherrack", 808).withSound(BlockSounds.STONE).withHardness(0.4F).withLitInteriorSurface(true)
+            .withTags(BlockTags.MINEABLE_BY_PICKAXE);
+        STAIRS_BRICK_NETHERRACK = new StairsBlock(BRICK_NETHERRACK, "minecraft:block/stairs_brick_netherrack", 809).withSound(BlockSounds.STONE).withHardness(0.4F).withLitInteriorSurface(true)
             .withTags(BlockTags.MINEABLE_BY_PICKAXE);
 
         SOULSAND = new SoulSandBlock("soulsand", "minecraft:block/soulsand", 810).withSound(BlockSounds.SAND).withHardness(0.5F).withOverrideColor(MaterialColor.paintedBrown)
diff --git a/src/main/java/net/minecraft/core/block/ChestBlock.java b/src/main/java/net/minecraft/core/block/ChestBlock.java
index 8565a79de..638e7035b 100644
--- a/src/main/java/net/minecraft/core/block/ChestBlock.java
+++ b/src/main/java/net/minecraft/core/block/ChestBlock.java
@@ -11,11 +11,12 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.container.CompoundContainer;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.slf4j.Logger;
 
-public class ChestBlock extends EntityBlock {
+public class ChestBlock extends EntityBlock implements IPaintable {
 	private static final Logger LOGGER = LogUtils.getLogger();
 	public ChestBlock(String key, String namespaceId, int id, Material material) {
 		super(key, namespaceId, id, material);
@@ -325,7 +326,14 @@ public class ChestBlock extends EntityBlock {
 	public static Type getTypeFromMeta(int meta) {
 		return Type.get((meta >> typeOffset) & 3);
 	}
-	
+
+	@Override
+	public void setColor(World world, int x, int y, int z, DyeColor color) {
+		final int meta = world.getBlockMetadata(x, y, z);
+		world.setBlockAndMetadata(x, y, z, Blocks.CHEST_PLANKS_OAK_PAINTED.id, meta);
+		((IPaintable) Blocks.CHEST_PLANKS_OAK_PAINTED).setColor(world, x, y, z, color);
+	}
+
 	// Enum
 	
 	public enum Type{
diff --git a/src/main/java/net/minecraft/core/block/ChestBlockPainted.java b/src/main/java/net/minecraft/core/block/ChestBlockPainted.java
index c894114c2..c2b5b78e2 100644
--- a/src/main/java/net/minecraft/core/block/ChestBlockPainted.java
+++ b/src/main/java/net/minecraft/core/block/ChestBlockPainted.java
@@ -5,10 +5,11 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class ChestBlockPainted extends ChestBlock {
+public class ChestBlockPainted extends ChestBlock implements IPainted {
 
 	protected ChestBlockPainted(String key, String namespaceId, int id, Material material) {
 		super(key, namespaceId, id, material);
@@ -32,4 +33,29 @@ public class ChestBlockPainted extends ChestBlock {
 	public static final int colorBits = 0b00000000_00000000_00000000_11110000;
 	public static final int colorOffset = 4;
 
+	@Override
+	public DyeColor fromMetadata(int meta) {
+		return DyeColor.colorFromBlockMeta((meta & colorBits) >> colorOffset);
+	}
+
+	@Override
+	public int toMetadata(DyeColor color) {
+		return color.blockMeta << colorOffset;
+	}
+
+	@Override
+	public int stripColorFromMetadata(int meta) {
+		return meta & ~colorBits;
+	}
+
+	@Override
+	public void removeDye(World world, int x, int y, int z) {
+		final int meta = stripColorFromMetadata(world.getBlockMetadata(x, y, z));
+		world.setBlockAndMetadataWithNotify(x, y, z, Blocks.CHEST_PLANKS_OAK.id, meta);
+	}
+
+	@Override
+	public void setColor(World world, int x, int y, int z, DyeColor color) {
+		IPainted.super.setColor(world, x, y, z, color);
+	}
 }
diff --git a/src/main/java/net/minecraft/core/block/DoorBlock.java b/src/main/java/net/minecraft/core/block/DoorBlock.java
index e0fd691f5..ee888acf1 100644
--- a/src/main/java/net/minecraft/core/block/DoorBlock.java
+++ b/src/main/java/net/minecraft/core/block/DoorBlock.java
@@ -5,6 +5,7 @@ import java.util.function.Supplier;
 
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
@@ -25,7 +26,7 @@ import org.jetbrains.annotations.Nullable;
 //            Item, AxisAlignedBB, Player, Vec3D,
 //            MovingObjectPosition
 
-public class DoorBlock extends Block
+public class DoorBlock extends Block implements IPaintable
 {
 
 	public final boolean isTop;
@@ -317,4 +318,20 @@ public class DoorBlock extends Block
     {
         return 1;
     }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        final int meta = world.getBlockMetadata(x, y, z);
+        if (isTop) {
+            world.setBlockAndMetadata(x, y, z, Blocks.DOOR_PLANKS_PAINTED_TOP.id, meta);
+            ((IPaintable) Blocks.DOOR_PLANKS_PAINTED_TOP).setColor(world, x, y, z, color);
+            world.setBlockAndMetadata(x, y - 1, z, Blocks.DOOR_PLANKS_PAINTED_BOTTOM.id, meta);
+            ((IPaintable) Blocks.DOOR_PLANKS_PAINTED_BOTTOM).setColor(world, x, y - 1, z, color);
+        } else {
+            world.setBlockAndMetadata(x, y, z, Blocks.DOOR_PLANKS_PAINTED_BOTTOM.id, meta);
+            ((IPaintable) Blocks.DOOR_PLANKS_PAINTED_BOTTOM).setColor(world, x, y, z, color);
+            world.setBlockAndMetadata(x, y + 1, z, Blocks.DOOR_PLANKS_PAINTED_TOP.id, meta);
+            ((IPaintable) Blocks.DOOR_PLANKS_PAINTED_TOP).setColor(world, x, y + 1, z, color);
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/DoorPaintedBlock.java b/src/main/java/net/minecraft/core/block/DoorPaintedBlock.java
index a2daae478..f857b9723 100644
--- a/src/main/java/net/minecraft/core/block/DoorPaintedBlock.java
+++ b/src/main/java/net/minecraft/core/block/DoorPaintedBlock.java
@@ -5,9 +5,10 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
 
-public class DoorPaintedBlock extends DoorBlock {
+public class DoorPaintedBlock extends DoorBlock implements IPainted {
     public DoorPaintedBlock(String key, String namespaceId, int id, Material material, boolean isTop) {
         super(key, namespaceId, id, material, isTop, false, null);
     }
@@ -16,4 +17,41 @@ public class DoorPaintedBlock extends DoorBlock {
     {
         return new ItemStack[] { new ItemStack(Items.DOOR_OAK_PAINTED, 1, 15 - (meta >> 4 & 0xF)) };
     }
+
+    @Override
+    public DyeColor fromMetadata(int meta) {
+        return DyeColor.colorFromBlockMeta(meta >> 4 & 0xF);
+    }
+
+    @Override
+    public int toMetadata(DyeColor color) {
+        return color.blockMeta << 4;
+    }
+
+    @Override
+    public int stripColorFromMetadata(int meta) {
+        return meta & 0xF;
+    }
+
+    @Override
+    public void removeDye(World world, int x, int y, int z) {
+        final int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockAndMetadataWithNotify(x, y, z, this.isTop ? Blocks.DOOR_PLANKS_OAK_TOP.id : Blocks.DOOR_PLANKS_OAK_BOTTOM.id, meta & 0xF);
+        if (this.isTop) {
+            world.setBlockAndMetadataWithNotify(x, y - 1, z, Blocks.DOOR_PLANKS_OAK_BOTTOM.id, meta & 0xF);
+        } else {
+            world.setBlockAndMetadataWithNotify(x, y + 1, z, Blocks.DOOR_PLANKS_OAK_TOP.id, meta & 0xF);
+        }
+    }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        final int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockMetadataWithNotify(x, y, z, meta & 0xF | toMetadata(color));
+        if (this.isTop) {
+            world.setBlockMetadataWithNotify(x, y - 1, z, meta & 0xF | toMetadata(color));
+        } else {
+            world.setBlockMetadataWithNotify(x, y + 1, z, meta & 0xF | toMetadata(color));
+        }
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/FenceBlock.java b/src/main/java/net/minecraft/core/block/FenceBlock.java
index c1b5f735c..5b6c71208 100644
--- a/src/main/java/net/minecraft/core/block/FenceBlock.java
+++ b/src/main/java/net/minecraft/core/block/FenceBlock.java
@@ -4,13 +4,15 @@ package net.minecraft.core.block;
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, World, AxisAlignedBB
 
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
 
-public class FenceBlock extends Block
+public class FenceBlock extends Block implements IPaintable
 {
 //    private static final List<BoundingVolume> selectionVolumes = new ArrayList<>();
 //
@@ -131,4 +133,10 @@ public class FenceBlock extends Block
         int l = iblockaccess.getBlockId(x, y, z);
         return Block.hasTag(l, BlockTags.FENCES_CONNECT);
     }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        world.setBlock(x, y, z, Blocks.FENCE_PLANKS_OAK_PAINTED.id);
+        ((IPaintable) Blocks.FENCE_PLANKS_OAK_PAINTED).setColor(world, x, y, z, color);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/FenceGateBlock.java b/src/main/java/net/minecraft/core/block/FenceGateBlock.java
index 0f7dc784c..65998b750 100644
--- a/src/main/java/net/minecraft/core/block/FenceGateBlock.java
+++ b/src/main/java/net/minecraft/core/block/FenceGateBlock.java
@@ -6,12 +6,13 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-public class FenceGateBlock extends Block
+public class FenceGateBlock extends Block implements IPaintable
 {
 
     public FenceGateBlock(String key, String namespaceId, int id)
@@ -126,4 +127,11 @@ public class FenceGateBlock extends Block
     {
         return i & 3;
     }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        final int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockAndMetadata(x, y, z, Blocks.FENCE_GATE_PLANKS_OAK_PAINTED.id, meta);
+        ((IPaintable) Blocks.FENCE_GATE_PLANKS_OAK_PAINTED).setColor(world, x, y, z, color);
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/IPaintable.java b/src/main/java/net/minecraft/core/block/IPaintable.java
new file mode 100644
index 000000000..8accbcf5b
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/IPaintable.java
@@ -0,0 +1,8 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.World;
+
+public interface IPaintable {
+    void setColor(World world, int x, int y, int z, DyeColor color);
+}
diff --git a/src/main/java/net/minecraft/core/block/IPainted.java b/src/main/java/net/minecraft/core/block/IPainted.java
new file mode 100644
index 000000000..a8a022920
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/IPainted.java
@@ -0,0 +1,21 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.World;
+
+public interface IPainted extends IPaintable {
+    DyeColor fromMetadata(int meta);
+    int toMetadata(DyeColor color);
+    int stripColorFromMetadata(int meta);
+
+    void removeDye(World world, int x, int y, int z);
+
+    default DyeColor getColor(World world, int x, int y, int z) {
+        return fromMetadata(world.getBlockMetadata(x, y, z));
+    }
+
+    default void setColor(World world, int x, int y, int z, DyeColor color) {
+        final int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockMetadataWithNotify(x, y, z, stripColorFromMetadata(meta) | toMetadata(color));
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/LampBlock.java b/src/main/java/net/minecraft/core/block/LampBlock.java
index be592ae3a..236df86fe 100644
--- a/src/main/java/net/minecraft/core/block/LampBlock.java
+++ b/src/main/java/net/minecraft/core/block/LampBlock.java
@@ -5,10 +5,11 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class LampBlock extends Block {
+public class LampBlock extends Block implements IPainted {
     public boolean isActive;
 
     public LampBlock(String key, String namespaceId, int id, boolean isActivated) {
@@ -46,4 +47,24 @@ public class LampBlock extends Block {
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity) {
         return new ItemStack[]{new ItemStack(Blocks.LAMP_IDLE, 1, meta)};
     }
+
+    @Override
+    public DyeColor fromMetadata(int meta) {
+        return DyeColor.colorFromBlockMeta(meta & 0x0F);
+    }
+
+    @Override
+    public int toMetadata(DyeColor color) {
+        return color.blockMeta;
+    }
+
+    @Override
+    public int stripColorFromMetadata(int meta) {
+        return 0;
+    }
+
+    @Override
+    public void removeDye(World world, int x, int y, int z) {
+        world.setBlockMetadataWithNotify(x, y, z, 0);
+    }
 }
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/block/PaintableSlabBlock.java b/src/main/java/net/minecraft/core/block/PaintableSlabBlock.java
new file mode 100644
index 000000000..96b12d38b
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/PaintableSlabBlock.java
@@ -0,0 +1,17 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.World;
+
+public class PaintableSlabBlock extends SlabBlock implements IPaintable {
+    public PaintableSlabBlock(Block modelBlock, String namespaceId, int id) {
+        super(modelBlock, namespaceId, id);
+    }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        final int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockAndMetadata(x, y, z, Blocks.SLAB_PLANKS_PAINTED.id, meta);
+        ((IPaintable) Blocks.SLAB_PLANKS_PAINTED).setColor(world, x, y, z, color);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/PaintableStairsBlock.java b/src/main/java/net/minecraft/core/block/PaintableStairsBlock.java
new file mode 100644
index 000000000..8cf9d16d0
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/PaintableStairsBlock.java
@@ -0,0 +1,17 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.world.World;
+
+public class PaintableStairsBlock extends StairsBlock implements IPaintable {
+    public PaintableStairsBlock(Block block, String namespaceId, int id) {
+        super(block, namespaceId, id);
+    }
+
+    @Override
+    public void setColor(World world, int x, int y, int z, DyeColor color) {
+        final int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockAndMetadata(x, y, z, Blocks.STAIRS_PLANKS_PAINTED.id, meta);
+        ((IPaintable) Blocks.STAIRS_PLANKS_PAINTED).setColor(world, x, y, z, color);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/PaintedFenceBlock.java b/src/main/java/net/minecraft/core/block/PaintedFenceBlock.java
index eb86be43d..79eb16a18 100644
--- a/src/main/java/net/minecraft/core/block/PaintedFenceBlock.java
+++ b/src/main/java/net/minecraft/core/block/PaintedFenceBlock.java
@@ -4,10 +4,11 @@ import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class PaintedFenceBlock extends FenceBlock
+public class PaintedFenceBlock extends FenceBlock implements IPainted
 {
 	public PaintedFenceBlock(String key, String namespaceId, int id)
 	{
@@ -25,8 +26,28 @@ public class PaintedFenceBlock extends FenceBlock
 		return new ItemStack[] { new ItemStack(this, 1, meta & 0x0F) };
 	}
 
-	public static int getMetadataForColour(int i)
-	{
-		return ~i & 0xF;
+	@Override
+	public DyeColor fromMetadata(int meta) {
+		return DyeColor.colorFromBlockMeta(meta & 0x0F);
+	}
+
+	@Override
+	public int toMetadata(DyeColor color) {
+		return color.blockMeta;
+	}
+
+	@Override
+	public int stripColorFromMetadata(int meta) {
+		return 0;
+	}
+
+	@Override
+	public void removeDye(World world, int x, int y, int z) {
+		world.setBlockWithNotify(x, y, z, Blocks.FENCE_PLANKS_OAK.id);
+	}
+
+	@Override
+	public void setColor(World world, int x, int y, int z, DyeColor color) {
+		IPainted.super.setColor(world, x, y, z, color);
 	}
 }
diff --git a/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java b/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java
index 625aca883..e4dc3f197 100644
--- a/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java
+++ b/src/main/java/net/minecraft/core/block/PaintedFenceGateBlock.java
@@ -4,10 +4,11 @@ import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 
-public class PaintedFenceGateBlock extends FenceGateBlock
+public class PaintedFenceGateBlock extends FenceGateBlock implements IPainted
 {
 	public PaintedFenceGateBlock(String key, String namespaceId, int id)
 	{
@@ -25,8 +26,29 @@ public class PaintedFenceGateBlock extends FenceGateBlock
 		return new ItemStack[] { new ItemStack(this, 1, meta & 0xF0) };
 	}
 
-	public static int getMetadataForColour(int i)
-	{
-		return (~i << 4) & 0xF0;
+	@Override
+	public DyeColor fromMetadata(int meta) {
+		return DyeColor.colorFromBlockMeta((meta & 0xF0) >> 4);
+	}
+
+	@Override
+	public int toMetadata(DyeColor color) {
+		return color.blockMeta << 4;
+	}
+
+	@Override
+	public int stripColorFromMetadata(int meta) {
+		return meta & 0xF;
+	}
+
+	@Override
+	public void removeDye(World world, int x, int y, int z) {
+		final int meta = world.getBlockMetadata(x, y, z);
+		world.setBlockAndMetadataWithNotify(x, y, z, Blocks.FENCE_GATE_PLANKS_OAK.id, meta & 0xF);
+	}
+
+	@Override
+	public void setColor(World world, int x, int y, int z, DyeColor color) {
+		IPainted.super.setColor(world, x, y, z, color);
 	}
 }
